/*	This file is part of Advantech VCOM Linux.
 *
 *	Copyright (c) 2009 - 2021 ADVANTECH CORPORATION.  All rights reserved. 
 *
 *	Advantech VCOM Linux is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	Advantech VCOM Linux  is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with Advantech VCOM Linux.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "overload.h"

typedef struct _t_treenode_data{
	int type;
	char *data;
}_treenode_data;

typedef struct _t_treenode{
	_treenode_data data;
	struct _t_treenode * l;
	struct _t_treenode * r;
}_tree_node;


static inline void *realloc_it(void *ptrmem, size_t size) {
	void *p = realloc(ptrmem, size);
	if (!p)  {
		free (ptrmem);
		fprintf(stderr, "realloc(): errno=%d\n", errno);
	}
	return p;
}

int dump(const char *js, jsmntok_t *t, size_t count, int indent);

typedef struct {
	int ret;
	_tree_node * node;
} jstreeret;

jstreeret js2tree(const char *js, jsmntok_t *t, size_t count);
_tree_node * _alloc_tree_node_len(int type, const char * data, int datalen);
_tree_node * _alloc_tree_node_data(int type, const char * data);
_tree_node * _alloc_tree_node_type(int type);

#define alloc_tree_node(args...)	ovrld3(args, _alloc_tree_node_len, \
						_alloc_tree_node_data, \
						_alloc_tree_node_type)(args)

_tree_node * find_node( _tree_node * tree, char * key);
_tree_node * next_node( _tree_node *node, int step);
int get_node_string( _tree_node *node, char *buf, int bufsize);
int dumptree(_tree_node * tree, int indent);
int tree2json(_tree_node * tree, char * buf, int bufsize);
void freewtree(_tree_node * tree);
